Package org.apache.naming

# Class SelectorContext

java.lang.Object
org.apache.naming.SelectorContext

All Implemented Interfaces:
  `Context`

public class SelectorContext extends Object implements Context
Catalina JNDI Context implementation.

Author:
  Remy Maucherat

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final Hashtable<String,Object>`
`env`
Environment.
`static final String`
`IC_PREFIX`
Initial context prefix.
`protected final boolean`
`initialContext`
Request for an initial context.
`static final String`
`prefix`
Namespace URL.
`static final int`
`prefixLength`
Namespace URL length.
`protected static final StringManager`
`sm`
The string manager for this package.

### Fields inherited from interface javax.naming.Context

`APPLET, AUTHORITATIVE, BATCHSIZE, DNS_URL, INITIAL_CONTEXT_FACTORY, LANGUAGE, OBJECT_FACTORIES, PROVIDER_URL, REFERRAL, SECURITY_AUTHENTICATION, SECURITY_CREDENTIALS, SECURITY_PRINCIPAL, SECURITY_PROTOCOL, STATE_FACTORIES, URL_PKG_PREFIXES`

## Constructor Summary

Constructors
Constructor
Description
`SelectorContext(Hashtable<String,Object> env)`
Builds a Catalina selector context using the given environment.
`SelectorContext(Hashtable<String,Object> env, boolean initialContext)`
Builds a Catalina selector context using the given environment.

## Method Summary

Modifier and Type
Method
Description
`Object`
`addToEnvironment(String propName, Object propVal)`
Adds a new environment property to the environment of this context.
`void`
`bind(String name, Object obj)`
Binds a name to an object.
`void`
`bind(Name name, Object obj)`
Binds a name to an object.
`void`
`close()`
Closes this context.
`String`
`composeName(String name, String prefix)`
Composes the name of this context with a name relative to this context.
`Name`
`composeName(Name name, Name prefix)`
Composes the name of this context with a name relative to this context.
`Context`
`createSubcontext(String name)`
Creates and binds a new context.
`Context`
`createSubcontext(Name name)`
Creates and binds a new context.
`void`
`destroySubcontext(String name)`
Destroys the named context and removes it from the namespace.
`void`
`destroySubcontext(Name name)`
Destroys the named context and removes it from the namespace.
`protected Context`
`getBoundContext()`
Get the bound context.
`Hashtable<?,?>`
`getEnvironment()`
Retrieves the environment in effect for this context.
`String`
`getNameInNamespace()`
Retrieves the full name of this context within its own namespace.
`NameParser`
`getNameParser(String name)`
Retrieves the parser associated with the named context.
`NameParser`
`getNameParser(Name name)`
Retrieves the parser associated with the named context.
`NamingEnumeration<NameClassPair>`
`list(String name)`
Enumerates the names bound in the named context, along with the class names of objects bound to them.
`NamingEnumeration<NameClassPair>`
`list(Name name)`
Enumerates the names bound in the named context, along with the class names of objects bound to them.
`NamingEnumeration<Binding>`
`listBindings(String name)`
Enumerates the names bound in the named context, along with the objects bound to them.
`NamingEnumeration<Binding>`
`listBindings(Name name)`
Enumerates the names bound in the named context, along with the objects bound to them.
`Object`
`lookup(String name)`
Retrieves the named object.
`Object`
`lookup(Name name)`
Retrieves the named object.
`Object`
`lookupLink(String name)`
Retrieves the named object, following links except for the terminal atomic component of the name.
`Object`
`lookupLink(Name name)`
Retrieves the named object, following links except for the terminal atomic component of the name.
`protected String`
`parseName(String name)`
Strips the URL header.
`protected Name`
`parseName(Name name)`
Strips the URL header.
`void`
`rebind(String name, Object obj)`
Binds a name to an object, overwriting any existing binding.
`void`
`rebind(Name name, Object obj)`
Binds a name to an object, overwriting any existing binding.
`Object`
`removeFromEnvironment(String propName)`
Removes an environment property from the environment of this context.
`void`
`rename(String oldName, String newName)`
Binds a new name to the object bound to an old name, and unbinds the old name.
`void`
`rename(Name oldName, Name newName)`
Binds a new name to the object bound to an old name, and unbinds the old name.
`void`
`unbind(String name)`
Unbinds the named object.
`void`
`unbind(Name name)`
Unbinds the named object.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### prefix

public static final String prefix
Namespace URL.

See Also:
  - Constant Field Values

### prefixLength

public static final int prefixLength
Namespace URL length.

### IC_PREFIX

public static final String IC_PREFIX
Initial context prefix.

See Also:
  - Constant Field Values

### env

protected final Hashtable<String,Object> env
Environment.

### sm

protected static final StringManager sm
The string manager for this package.

### initialContext

protected final boolean initialContext
Request for an initial context.

## Constructor Details

### SelectorContext

public SelectorContext(Hashtable<String,Object> env)
Builds a Catalina selector context using the given environment.

Parameters:
  `env` - The environment

### SelectorContext

public SelectorContext(Hashtable<String,Object> env, boolean initialContext)
Builds a Catalina selector context using the given environment.

Parameters:
  `env` - The environment
  `initialContext` - `true` if this is the main initial context

## Method Details

### lookup

public Object lookup(Name name) throws NamingException
Retrieves the named object. If name is empty, returns a new instance of this context (which represents the same naming context as this context, but its environment may be modified independently and it may be accessed concurrently).

Specified by:
  `lookup` in interface `Context`
Parameters:
  `name` - the name of the object to look up
Returns:
  the object bound to name
Throws:
  `NamingException` - if a naming exception is encountered

### lookup

public Object lookup(String name) throws NamingException
Retrieves the named object.

Specified by:
  `lookup` in interface `Context`
Parameters:
  `name` - the name of the object to look up
Returns:
  the object bound to name
Throws:
  `NamingException` - if a naming exception is encountered

### bind

public void bind(Name name, Object obj) throws NamingException
Binds a name to an object. All intermediate contexts and the target context (that named by all but terminal atomic component of the name) must already exist.

Specified by:
  `bind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
  `obj` - the object to bind; possibly null
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `InvalidAttributesException` - if object did not supply all mandatory attributes
  `NamingException` - if a naming exception is encountered

### bind

public void bind(String name, Object obj) throws NamingException
Binds a name to an object.

Specified by:
  `bind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
  `obj` - the object to bind; possibly null
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `InvalidAttributesException` - if object did not supply all mandatory attributes
  `NamingException` - if a naming exception is encountered

### rebind

public void rebind(Name name, Object obj) throws NamingException
Binds a name to an object, overwriting any existing binding. All intermediate contexts and the target context (that named by all but terminal atomic component of the name) must already exist.

If the object is a DirContext, any existing attributes associated with the name are replaced with those of the object. Otherwise, any existing attributes associated with the name remain unchanged.

Specified by:
  `rebind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
  `obj` - the object to bind; possibly null
Throws:
  `InvalidAttributesException` - if object did not supply all mandatory attributes
  `NamingException` - if a naming exception is encountered

### rebind

public void rebind(String name, Object obj) throws NamingException
Binds a name to an object, overwriting any existing binding.

Specified by:
  `rebind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
  `obj` - the object to bind; possibly null
Throws:
  `InvalidAttributesException` - if object did not supply all mandatory attributes
  `NamingException` - if a naming exception is encountered

### unbind

public void unbind(Name name) throws NamingException
Unbinds the named object. Removes the terminal atomic name in name from the target context--that named by all but the terminal atomic part of name.

This method is idempotent. It succeeds even if the terminal atomic name is not bound in the target context, but throws NameNotFoundException if any of the intermediate contexts do not exist.

Specified by:
  `unbind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
Throws:
  `NameNotFoundException` - if an intermediate context does not exist
  `NamingException` - if a naming exception is encountered

### unbind

public void unbind(String name) throws NamingException
Unbinds the named object.

Specified by:
  `unbind` in interface `Context`
Parameters:
  `name` - the name to bind; may not be empty
Throws:
  `NameNotFoundException` - if an intermediate context does not exist
  `NamingException` - if a naming exception is encountered

### rename

public void rename(Name oldName, Name newName) throws NamingException
Binds a new name to the object bound to an old name, and unbinds the old name. Both names are relative to this context. Any attributes associated with the old name become associated with the new name. Intermediate contexts of the old name are not changed.

Specified by:
  `rename` in interface `Context`
Parameters:
  `oldName` - the name of the existing binding; may not be empty
  `newName` - the name of the new binding; may not be empty
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `NamingException` - if a naming exception is encountered

### rename

public void rename(String oldName, String newName) throws NamingException
Binds a new name to the object bound to an old name, and unbinds the old name.

Specified by:
  `rename` in interface `Context`
Parameters:
  `oldName` - the name of the existing binding; may not be empty
  `newName` - the name of the new binding; may not be empty
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `NamingException` - if a naming exception is encountered

### list

public NamingEnumeration<NameClassPair> list(Name name) throws NamingException
Enumerates the names bound in the named context, along with the class names of objects bound to them. The contents of any subcontexts are not included.

If a binding is added to or removed from this context, its effect on an enumeration previously returned is undefined.

Specified by:
  `list` in interface `Context`
Parameters:
  `name` - the name of the context to list
Returns:
  an enumeration of the names and class names of the bindings in this context. Each element of the enumeration is of type NameClassPair.
Throws:
  `NamingException` - if a naming exception is encountered

### list

public NamingEnumeration<NameClassPair> list(String name) throws NamingException
Enumerates the names bound in the named context, along with the class names of objects bound to them.

Specified by:
  `list` in interface `Context`
Parameters:
  `name` - the name of the context to list
Returns:
  an enumeration of the names and class names of the bindings in this context. Each element of the enumeration is of type NameClassPair.
Throws:
  `NamingException` - if a naming exception is encountered

### listBindings

public NamingEnumeration<Binding> listBindings(Name name) throws NamingException
Enumerates the names bound in the named context, along with the objects bound to them. The contents of any subcontexts are not included.

If a binding is added to or removed from this context, its effect on an enumeration previously returned is undefined.

Specified by:
  `listBindings` in interface `Context`
Parameters:
  `name` - the name of the context to list
Returns:
  an enumeration of the bindings in this context. Each element of the enumeration is of type Binding.
Throws:
  `NamingException` - if a naming exception is encountered

### listBindings

public NamingEnumeration<Binding> listBindings(String name) throws NamingException
Enumerates the names bound in the named context, along with the objects bound to them.

Specified by:
  `listBindings` in interface `Context`
Parameters:
  `name` - the name of the context to list
Returns:
  an enumeration of the bindings in this context. Each element of the enumeration is of type Binding.
Throws:
  `NamingException` - if a naming exception is encountered

### destroySubcontext

public void destroySubcontext(Name name) throws NamingException
Destroys the named context and removes it from the namespace. Any attributes associated with the name are also removed. Intermediate contexts are not destroyed.

This method is idempotent. It succeeds even if the terminal atomic name is not bound in the target context, but throws NameNotFoundException if any of the intermediate contexts do not exist. In a federated naming system, a context from one naming system may be bound to a name in another. One can subsequently look up and perform operations on the foreign context using a composite name. However, an attempt destroy the context using this composite name will fail with NotContextException, because the foreign context is not a "subcontext" of the context in which it is bound. Instead, use unbind() to remove the binding of the foreign context. Destroying the foreign context requires that the destroySubcontext() be performed on a context from the foreign context's "native" naming system.

Specified by:
  `destroySubcontext` in interface `Context`
Parameters:
  `name` - the name of the context to be destroyed; may not be empty
Throws:
  `NameNotFoundException` - if an intermediate context does not exist
  `NotContextException` - if the name is bound but does not name a context, or does not name a context of the appropriate type
  `NamingException`

### destroySubcontext

public void destroySubcontext(String name) throws NamingException
Destroys the named context and removes it from the namespace.

Specified by:
  `destroySubcontext` in interface `Context`
Parameters:
  `name` - the name of the context to be destroyed; may not be empty
Throws:
  `NameNotFoundException` - if an intermediate context does not exist
  `NotContextException` - if the name is bound but does not name a context, or does not name a context of the appropriate type
  `NamingException`

### createSubcontext

public Context createSubcontext(Name name) throws NamingException
Creates and binds a new context. Creates a new context with the given name and binds it in the target context (that named by all but terminal atomic component of the name). All intermediate contexts and the target context must already exist.

Specified by:
  `createSubcontext` in interface `Context`
Parameters:
  `name` - the name of the context to create; may not be empty
Returns:
  the newly created context
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `InvalidAttributesException` - if creation of the sub-context requires specification of mandatory attributes
  `NamingException` - if a naming exception is encountered

### createSubcontext

public Context createSubcontext(String name) throws NamingException
Creates and binds a new context.

Specified by:
  `createSubcontext` in interface `Context`
Parameters:
  `name` - the name of the context to create; may not be empty
Returns:
  the newly created context
Throws:
  `NameAlreadyBoundException` - if name is already bound
  `InvalidAttributesException` - if creation of the sub-context requires specification of mandatory attributes
  `NamingException` - if a naming exception is encountered

### lookupLink

public Object lookupLink(Name name) throws NamingException
Retrieves the named object, following links except for the terminal atomic component of the name. If the object bound to name is not a link, returns the object itself.

Specified by:
  `lookupLink` in interface `Context`
Parameters:
  `name` - the name of the object to look up
Returns:
  the object bound to name, not following the terminal link (if any).
Throws:
  `NamingException` - if a naming exception is encountered

### lookupLink

public Object lookupLink(String name) throws NamingException
Retrieves the named object, following links except for the terminal atomic component of the name.

Specified by:
  `lookupLink` in interface `Context`
Parameters:
  `name` - the name of the object to look up
Returns:
  the object bound to name, not following the terminal link (if any).
Throws:
  `NamingException` - if a naming exception is encountered

### getNameParser

public NameParser getNameParser(Name name) throws NamingException
Retrieves the parser associated with the named context. In a federation of namespaces, different naming systems will parse names differently. This method allows an application to get a parser for parsing names into their atomic components using the naming convention of a particular naming system. Within any single naming system, NameParser objects returned by this method must be equal (using the equals() test).

Specified by:
  `getNameParser` in interface `Context`
Parameters:
  `name` - the name of the context from which to get the parser
Returns:
  a name parser that can parse compound names into their atomic components
Throws:
  `NamingException` - if a naming exception is encountered

### getNameParser

public NameParser getNameParser(String name) throws NamingException
Retrieves the parser associated with the named context.

Specified by:
  `getNameParser` in interface `Context`
Parameters:
  `name` - the name of the context from which to get the parser
Returns:
  a name parser that can parse compound names into their atomic components
Throws:
  `NamingException` - if a naming exception is encountered

### composeName

public Name composeName(Name name, Name prefix) throws NamingException
Composes the name of this context with a name relative to this context.

Given a name (name) relative to this context, and the name (prefix) of this context relative to one of its ancestors, this method returns the composition of the two names using the syntax appropriate for the naming system(s) involved. That is, if name names an object relative to this context, the result is the name of the same object, but relative to the ancestor context. None of the names may be null.

Specified by:
  `composeName` in interface `Context`
Parameters:
  `name` - a name relative to this context
  `prefix` - the name of this context relative to one of its ancestors
Returns:
  the composition of prefix and name
Throws:
  `NamingException` - if a naming exception is encountered

### composeName

public String composeName(String name, String prefix) throws NamingException
Composes the name of this context with a name relative to this context.

Specified by:
  `composeName` in interface `Context`
Parameters:
  `name` - a name relative to this context
  `prefix` - the name of this context relative to one of its ancestors
Returns:
  the composition of prefix and name
Throws:
  `NamingException` - if a naming exception is encountered

### addToEnvironment

public Object addToEnvironment(String propName, Object propVal) throws NamingException
Adds a new environment property to the environment of this context. If the property already exists, its value is overwritten.

Specified by:
  `addToEnvironment` in interface `Context`
Parameters:
  `propName` - the name of the environment property to add; may not be null
  `propVal` - the value of the property to add; may not be null
Throws:
  `NamingException` - if a naming exception is encountered

### removeFromEnvironment

public Object removeFromEnvironment(String propName) throws NamingException
Removes an environment property from the environment of this context.

Specified by:
  `removeFromEnvironment` in interface `Context`
Parameters:
  `propName` - the name of the environment property to remove; may not be null
Throws:
  `NamingException` - if a naming exception is encountered

### getEnvironment

public Hashtable<?,?> getEnvironment() throws NamingException
Retrieves the environment in effect for this context. See class description for more details on environment properties. The caller should not make any changes to the object returned: their effect on the context is undefined. The environment of this context may be changed using addToEnvironment() and removeFromEnvironment().

Specified by:
  `getEnvironment` in interface `Context`
Returns:
  the environment of this context; never null
Throws:
  `NamingException` - if a naming exception is encountered

### close

public void close() throws NamingException
Closes this context. This method releases this context's resources immediately, instead of waiting for them to be released automatically by the garbage collector. This method is idempotent: invoking it on a context that has already been closed has no effect. Invoking any other method on a closed context is not allowed, and results in undefined behaviour.

Specified by:
  `close` in interface `Context`
Throws:
  `NamingException` - if a naming exception is encountered

### getNameInNamespace

public String getNameInNamespace() throws NamingException
Retrieves the full name of this context within its own namespace.

Many naming services have a notion of a "full name" for objects in their respective namespaces. For example, an LDAP entry has a distinguished name, and a DNS record has a fully qualified name. This method allows the client application to retrieve this name. The string returned by this method is not a JNDI composite name and should not be passed directly to context methods. In naming systems for which the notion of full name does not make sense, OperationNotSupportedException is thrown.

Specified by:
  `getNameInNamespace` in interface `Context`
Returns:
  this context's name in its own namespace; never null
Throws:
  `OperationNotSupportedException` - if the naming system does not have the notion of a full name
  `NamingException` - if a naming exception is encountered

### getBoundContext

protected Context getBoundContext() throws NamingException
Get the bound context.

Returns:
  the Context bound with either the current thread or the current classloader
Throws:
  `NamingException` - Bindings exception

### parseName

protected String parseName(String name) throws NamingException
Strips the URL header.

Parameters:
  `name` - The name
Returns:
  the parsed name
Throws:
  `NamingException` - if there is no "java:" header or if no naming context has been bound to this thread

### parseName

protected Name parseName(Name name) throws NamingException
Strips the URL header.

Parameters:
  `name` - The name
Returns:
  the parsed name
Throws:
  `NamingException` - if there is no "java:" header or if no naming context has been bound to this thread